package  geometry._theory 
{
	import flash.display.Sprite;
	import flash.geom.Matrix;
	import flash.geom.Matrix3D;
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class C_MatrixMultiply extends Sprite 
	{
		
		public function C_MatrixMultiply() 
		{
			var a:Matrix3D = new Matrix3D( Vector.<Number>( [	1, 0, 0, 0,
																0, 1, 0, 0,
																0, 0, 1, 0,
																0, 0, 0, 1		] ) );
			
			var b:Matrix3D = new Matrix3D( Vector.<Number>( [	1, 0, 0, 0,
																0, 1, 0, 0,
																0, 0, 1, 0,
																0, 0, 0, 1		] ) );
			
			var c:Matrix3D = multiply( a, b );
			
			traceMatrix( c );
			
		}
		
		private function multiply(a:Matrix3D, b:Matrix3D):Matrix3D 
		{
			
			var a0:Number = a.rawData[ 0 ];
			var a1:Number = a.rawData[ 1 ];
			var a2:Number = a.rawData[ 2 ];
			var a3:Number = a.rawData[ 3 ];
			var a4:Number = a.rawData[ 4 ];
			var a5:Number = a.rawData[ 5 ];
			var a6:Number = a.rawData[ 6 ];
			var a7:Number = a.rawData[ 7 ];
			var a8:Number = a.rawData[ 8 ];
			var a9:Number = a.rawData[ 9 ];
			var a10:Number = a.rawData[ 10 ];
			var a11:Number = a.rawData[ 11 ];
			var a12:Number = a.rawData[ 12 ];
			var a13:Number = a.rawData[ 13 ];
			var a14:Number = a.rawData[ 14 ];
			var a15:Number = a.rawData[ 15 ];
			
			
			var b0:Number = b.rawData[ 0 ];
			var b1:Number = b.rawData[ 1 ];
			var b2:Number = b.rawData[ 2 ];
			var b3:Number = b.rawData[ 3 ];
			var b4:Number = b.rawData[ 4 ];
			var b5:Number = b.rawData[ 5 ];
			var b6:Number = b.rawData[ 6 ];
			var b7:Number = b.rawData[ 7 ];
			var b8:Number = b.rawData[ 8 ];
			var b9:Number = b.rawData[ 9 ];
			var b10:Number = b.rawData[ 10 ];
			var b11:Number = b.rawData[ 11 ];
			var b12:Number = b.rawData[ 12 ];
			var b13:Number = b.rawData[ 13 ];
			var b14:Number = b.rawData[ 14 ];
			var b15:Number = b.rawData[ 15 ];
			
			
			var c:Matrix3D = new Matrix3D();
			
			c.rawData = Vector.<Number>([	a0 * b0 + a1 * b4 + a2 * b8  + a3 * b12,
											a0 * b1 + a1 * b5 + a2 * b9  + a3 * b13,
											a0 * b2 + a1 * b6 + a2 * b10 + a3 * b14,
											a0 * b3 + a1 * b7 + a2 * b11 + a3 * b15,
											
											a4 * b0 + a5 * b4 + a6 * b8  + a7 * b12,
											a4 * b1 + a5 * b5 + a6 * b9  + a7 * b13,
											a4 * b2 + a5 * b6 + a6 * b10 + a7 * b14,
											a4 * b3 + a5 * b7 + a6 * b11 + a7 * b15,
											
											a8 * b0 + a9 * b4 + a10 * b8  + a11 * b12,
											a8 * b1 + a9 * b5 + a10 * b9  + a11 * b13,
											a8 * b2 + a9 * b6 + a10 * b10 + a11 * b14,
											a8 * b3 + a9 * b7 + a10 * b11 + a11 * b15,
											
											a12 * b0 + a13 * b4 + a14 * b8  + a15 * b12,
											a12 * b1 + a13 * b5 + a14 * b9  + a15 * b13,
											a12 * b2 + a13 * b6 + a14 * b10 + a15 * b14,
											a12 * b3 + a13 * b7 + a14 * b11 + a15 * b15		]);
			return c;
			
		}
		
		private function traceMatrix(m:Matrix3D, precision:uint = 2 ):String
		{
			var raw:Vector.<Number> = m.rawData;
			
			var str:String = '';
			
			str += '| ' + raw[ 0 ].toFixed( precision ) +', ' + raw[ 1 ].toFixed( precision ) + ', ' + raw[ 2 ].toFixed( precision ) + ', ' + raw[ 3 ].toFixed( precision ) 	+ '|\n';
			str += '| ' + raw[ 4 ].toFixed( precision ) +', ' + raw[ 5 ].toFixed( precision ) + ', ' + raw[ 6 ].toFixed( precision ) + ', ' + raw[ 7 ].toFixed( precision ) 	+ '|\n';
			str += '| ' + raw[ 8 ].toFixed( precision ) +', ' + raw[ 9 ].toFixed( precision ) + ', ' + raw[ 10 ].toFixed( precision ) + ', ' + raw[ 11 ].toFixed( precision ) 	+ '|\n';
			str += '| ' + raw[ 12 ].toFixed( precision ) +', ' + raw[ 13 ].toFixed( precision ) + ', ' + raw[ 14 ].toFixed( precision ) + ', ' + raw[ 15 ].toFixed( precision ) + '|';
			
			trace( str + '\n----------------------' );
			
			return str;
		}
	}

}