package  geometry._theory 
{
	import away3d.primitives.Cube;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;
	import triga.shapes.Tick;
	import triga.shapes.XYZ;
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class D_MatrixTransform extends BaseScene 
	{
		private var nativeAPI:Cube;
		private var manualTransform:Tick;
		
		public function D_MatrixTransform() 
		{
			cameraDistance = -250;
			setup();
			addMesh( new XYZ(100), nativeAPI = new Cube(RED, 10,10,10), manualTransform = new Tick( null, 25, WHITE ) );
			RED.alpha = .5;
			
			
			//creates a transform Matrix in 3D
			var mat:Matrix3D = new Matrix3D();
			
			//applies a translation to the matrix
			mat.prependTranslation( 50, 50, 50 );
			
				//scale
				//mat.appendScale( 2,2,2 );
			
			
			///*
			//transforms the position of the object
			//we grab the position of the 3d object
			var nativePoint:Vector3D = nativeAPI.position;
			
			//then re assigns the position of the object
			nativeAPI.position = mat.transformVector( nativePoint );
			
			//*/
			
			
			
			/*
			//here's what is happening internally
			//this will be our output position
			var v:Vector3D = new Vector3D();
			
			//we grab the position of the 3d object
			var p:Vector3D = manualTransform.position;
			
			//then we grab the raw data of the matrix3D
			var raw:Vector.<Number> = mat.rawData;
			
			//and perform a Matrix multiplication between the P vector and the transform matrix
			
			//TADA !
			v.x = raw[0] * p.x + raw[4] * p.y + raw[8] * p.z + raw[12] * p.w;
			v.y = raw[1] * p.x + raw[5] * p.y + raw[9] * p.z + raw[13] * p.w;
			v.z = raw[2] * p.x + raw[6] * p.y + raw[10] * p.z + raw[14] * p.w;
			v.w = raw[3] * p.x + raw[7] * p.y + raw[11] * p.z + raw[15] * p.w;
			
			//then re assigns the position of the object
			manualTransform.position = v;
			//*/
			
			
		}
		
	}

}