package geometry.basics 
{
	
	import away3d.core.base.Object3D;
	import away3d.primitives.*;
	
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class A_Primitives extends BaseScene 
	{
		
		private var shapeList:Vector.<Object3D> = new Vector.<Object3D>();
		
		public function A_Primitives() 
		{
			
			setup();
			
			var objectSize:Number = 100;
			
			var plane:Plane = new Plane( RED,  objectSize, objectSize );
			shapeList.push( plane );
			
			var cube:Cube = new Cube( BLUE, objectSize, objectSize, objectSize );
			shapeList.push( cube );
			
			var cone:Cone = new Cone( YELLOW, objectSize * .5, objectSize );
			shapeList.push( cone );
			
			var sphere:Sphere = new Sphere( GREEN, objectSize * .5 );
			shapeList.push( sphere );
			
			var cylinder:Cylinder = new Cylinder( RED, objectSize * .5, objectSize * .5, objectSize); 
			shapeList.push( cylinder );
			
			var capsule:Capsule = new Capsule( BLUE, objectSize * .5, objectSize * .5 );
			shapeList.push( capsule );
			
			var Wsphere:WireframeSphere = new WireframeSphere( objectSize * .5, 8, 6, YELLOW.color  );
			Wsphere.thickness = 3;
			shapeList.push( Wsphere );
			
			var WCube:WireframeCube = new WireframeCube( objectSize, objectSize, objectSize, GREEN.color  );
			WCube.thickness = 3;
			shapeList.push( WCube );
			
			var WGrid:WireframeGrid = new WireframeGrid( 5, objectSize, 3, RED.color  );
			shapeList.push( WGrid );
			
			
			var count:int = Math.sqrt( shapeList.length );
			
			var margin:Number = 50;
			var size:int = ( count * objectSize ) + ( ( count - 1 ) *  margin );
			
			var i:int = 0;
			for ( i = 0; i < shapeList.length; i++) 
			{
				
				var obj:Object3D = shapeList[ i ];
				
				obj.x = -size / 2 + ( objectSize + margin ) * ( i % count );
				obj.y = size / 2 - ( objectSize  + margin ) * int( i / count );
			 
				addMesh( obj );
				
			}
			
		}
		
	}

}