package geometry.lathe 
{
	import away3d.entities.Mesh;
	import flash.display.BitmapData;
	import flash.geom.Vector3D;
	import triga.lathe.Lathe;
	import triga.lathe.Profile;
	import triga.render.MaterialHelper;
	import triga.spline.curves.Cubic;
	
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class BasicLathe extends BaseScene
	{
		[Embed(source="../../../lib/res/textures/cubemap_512.png")]
		private var envMapSource:Class;
		private var envMap:BitmapData = new envMapSource().bitmapData;
		
		public function BasicLathe() 
		{
			
			lightsDistance = 1000;
			setup();
			
			var path:Vector.<Vector3D> = new Vector.<Vector3D>();
			
			path.push( 	new Vector3D(), 
						new Vector3D( 10, 0, 0 ),  
						new Vector3D( 50, 0, 0 ), 
						new Vector3D( 70, 20, 0 ), 
						new Vector3D( 10, 50, 0 ), 
						new Vector3D( 10, 150, 0 )
						);
			
			path = Cubic.compute( path );
			
			var profile:Profile = new Profile( path );
			profile.offset( new Vector3D( 5 ) );
			
			var lathe:Lathe = new Lathe( Vector3D.Y_AXIS, profile, 32, 1 );
			
			var mesh:Mesh = lathe.mesh;
			addMesh( mesh );
			mesh.y = -50;
			
			addChild( GlobalTextField.instance );
			
			WHITE.alpha = .5;
			mesh.material = MaterialHelper.createEnvrionmentMap( WHITE, envMap );
			mesh.material.lights = lights;
			
			
		}
		
	}

}