package geometry.lathe 
{
	import away3d.entities.Mesh;
	import com.bit101.components.RadioButton;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Vector3D;
	import geometry.DrawPanel;
	import triga.lathe.Lathe;
	import triga.lathe.Profile;
	import triga.render.MaterialHelper;
	import triga.spline.curves.Cubic;
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class Editor extends BaseScene 
	{
		private var panel:DrawPanel;
		private var profile:Profile;
		private var lathe:Lathe;
		private var mesh:Mesh;
		
		private var axis:Vector3D = Vector3D.Y_AXIS;
		private var X:RadioButton;
		private var Y:RadioButton;
		private var Z:RadioButton;
		
		public function Editor() 
		{
			setup();
			
			X = new RadioButton( this, 10, 10, 'X', false, onAxisChange );
			Y = new RadioButton( this, 40, 10, 'Y', true, onAxisChange );
			Z = new RadioButton( this, 70, 10, 'Z', false, onAxisChange );
			X.groupName = Y.groupName = Z.groupName = "axis";
			
			panel = new DrawPanel( 'profile', 400, 400, 10 );
			panel.addEventListener( DrawPanel.CHANGE, onChange );
			panel.addEventListener( DrawPanel.UPDATE, onUpdate );
			addChild( panel );
			panel.x = 10;
			panel.y = 30;
		}
		
		private function onAxisChange( e:Event = null ):void 
		{
			if ( e.target == X ) axis = Vector3D.X_AXIS;
			if ( e.target == Y ) axis = Vector3D.Y_AXIS;
			if ( e.target == Z ) axis = Vector3D.Z_AXIS;
			onChange( null );
		}
		
		private function onUpdate(e:Event):void 
		{
			
			var points:Vector.<Point> = panel.points.concat();
			var path:Vector.<Vector3D> = new Vector.<Vector3D>();
			for each (var p:Point in points) 
			{
				path.push( new Vector3D( p.x, -p.y, 0 ) );
			}
			profile.path = path;
			lathe.update();
			
		}
		
		private function onChange(e:Event):void 
		{
			
			var points:Vector.<Point> = panel.points.concat();
			var path:Vector.<Vector3D> = new Vector.<Vector3D>();
			for each (var p:Point in points) 
			{
				path.push( new Vector3D( p.x, -p.y, 0 ) );
			}
			
			profile = new Profile( path );
			lathe = new Lathe( axis, profile, 32, 1 );
			
			if ( mesh != null )
			{
				removeMesh( mesh );
				mesh = null;
			}
			
			mesh = lathe.mesh;
			addMesh( mesh );
			
			mesh.material = UV_DEBUG;
			
		}
		
	}

}